from telegram.ext import CallbackContext
from telegram import Update
from logging_script import logger
from db import get_user_details
from config import filters_list

async def user_panel(update: Update, context: CallbackContext):
    user = update.message.from_user
    user_id = user.id
    
    # Get user details from the database
    user_details = get_user_details(user_id)
    
    if user_details:
        user_id, perm1, perm2, perm3, perm4, count = user_details
        message = f"""
        اطلاعات کاربر:

        - آیدی عددی: {user_id}

        دسترسی‌ها 

        - {filters_list[0]} : {'✅' if perm1 else '❌'}

        - {filters_list[1]} : {'✅' if perm2 else '❌'}

        - {filters_list[2]} : {'✅' if perm3 else '❌'}

        - {filters_list[3]} : {'✅' if perm4 else '❌'}

        - تعداد آگهی دریافتی: {count}
        """
    else:
        message = f"""
        اطلاعاتی دریافت نشد!

        - آیدی عددی: {user_id}
        """
    
    await update.message.reply_text(message)

    