<?php

function send($api, $amount, $redirect, $factorNumber = null) {
    $ch = curl_init();
    curl_setopt_array($ch, [
        CURLOPT_URL => 'https://pay.ir/payment/send',
        CURLOPT_POST => true,
        CURLOPT_POSTFIELDS => http_build_query([
            'api' => $api,
            'amount' => $amount,
            'redirect' => $redirect,
            'factorNumber' => $factorNumber
        ]),
        CURLOPT_SSL_VERIFYPEER => false,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_TIMEOUT => 30
    ]);
    
    $response = curl_exec($ch);
    $error = curl_error($ch);
    curl_close($ch);

    if ($error) {
        return json_encode(['status' => 0, 'errorMessage' => 'خطا در ارتباط با سرور پرداخت']);
    }
    
    return $response;
}

function verify($api, $transId) {
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, 'https://pay.ir/payment/verify');
    curl_setopt($ch, CURLOPT_POSTFIELDS, "api=$api&transId=$transId");
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
    $res = curl_exec($ch);
    curl_close($ch);
    return $res;
}